"use strict";
/*****************************************************************************\
|                                               ( )_  _                       |
|    _ _    _ __   _ _    __    ___ ___     _ _ | ,_)(_)  ___   ___     _     |
|   ( '_`\ ( '__)/'_` ) /'_ `\/' _ ` _ `\ /'_` )| |  | |/',__)/' v `\ /'_`\   |
|   | (_) )| |  ( (_| |( (_) || ( ) ( ) |( (_| || |_ | |\__, \| (˅) |( (_) )  |
|   | ,__/'(_)  `\__,_)`\__  |(_) (_) (_)`\__,_)`\__)(_)(____/(_) (_)`\___/'  |
|   | |                ( )_) |                                                |
|   (_)                 \___/'                                                |
|                                                                             |
| General Bots Copyright (c) Pragmatismo.io. All rights reserved.             |
| Licensed under the AGPL-3.0.                                                |
|                                                                             |
| According to our dual licensing model, this program can be used either      |
| under the terms of the GNU Affero General Public License, version 3,        |
| or under a proprietary license.                                             |
|                                                                             |
| The texts of the GNU Affero General Public License with an additional       |
| permission and of our proprietary license can be found at and               |
| in the LICENSE file you have received along with this program.              |
|                                                                             |
| This program is distributed in the hope that it will be useful,             |
| but WITHOUT ANY WARRANTY, without even the implied warranty of              |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                |
| GNU Affero General Public License for more details.                         |
|                                                                             |
| "General Bots" is a registered trademark of Pragmatismo.io.                 |
| The licensing of the program under the AGPLv3 does not imply a              |
| trademark license. Therefore any rights, title and interest in              |
| our trademarks remain entirely with us.                                     |
|                                                                             |
\*****************************************************************************/
Object.defineProperty(exports, "__esModule", { value: true });
exports.CSService = void 0;
const models_1 = require("../../../packages/kb.gbapp/models");
const models_2 = require("../models");
/**
 * Customer Satisfaction Service Layer.
 */
class CSService {
    async getQuestionFromAlternateText(instanceId, text) {
        const questionAlternate = await models_2.GuaribasQuestionAlternate.findOne({
            where: {
                instanceId: instanceId,
                questionTyped: text
            }
        });
        let question = null;
        if (questionAlternate !== null) {
            question = await models_1.GuaribasQuestion.findOne({
                where: {
                    instanceId: instanceId,
                    questionId: questionAlternate.questionTyped
                }
            });
        }
        return question;
    }
    async insertQuestionAlternate(instanceId, questionTyped, questionText) {
        return await models_2.GuaribasQuestionAlternate.create({
            questionTyped: questionTyped,
            questionText: questionText
        });
    }
    async updateConversationRate(conversation, rate) {
        conversation.rate = rate;
        return conversation.save();
    }
}
exports.CSService = CSService;
//# sourceMappingURL=CSService.js.map