/*****************************************************************************\
|                                               ( )_  _                       |
|    _ _    _ __   _ _    __    ___ ___     _ _ | ,_)(_)  ___   ___     _     |
|   ( '_`\ ( '__)/'_` ) /'_ `\/' _ ` _ `\ /'_` )| |  | |/',__)/' v `\ /'_`\   |
|   | (_) )| |  ( (_| |( (_) || ( ) ( ) |( (_| || |_ | |\__, \| (˅) |( (_) )  |
|   | ,__/'(_)  `\__,_)`\__  |(_) (_) (_)`\__,_)`\__)(_)(____/(_) (_)`\___/'  |
|   | |                ( )_) |                                                |
|   (_)                 \___/'                                                |
|                                                                             |
| General Bots Copyright (c) Pragmatismo.io. All rights reserved.             |
| Licensed under the AGPL-3.0.                                                |
|                                                                             |
| According to our dual licensing model, this program can be used either      |
| under the terms of the GNU Affero General Public License, version 3,        |
| or under a proprietary license.                                             |
|                                                                             |
| The texts of the GNU Affero General Public License with an additional       |
| permission and of our proprietary license can be found at and               |
| in the LICENSE file you have received along with this program.              |
|                                                                             |
| This program is distributed in the hope that it will be useful,             |
| but WITHOUT ANY WARRANTY, without even the implied warranty of              |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                |
| GNU Affero General Public License for more details.                         |
|                                                                             |
| "General Bots" is a registered trademark of Pragmatismo.io.                 |
| The licensing of the program under the AGPLv3 does not imply a              |
| trademark license. Therefore any rights, title and interest in              |
| our trademarks remain entirely with us.                                     |
|                                                                             |
\*****************************************************************************/
/**
 * @fileoverview General Bots server core.
 */
'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GuaribasUserGroup = exports.GuaribasGroup = exports.GuaribasUser = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const GBModel_1 = require("../../core.gbapp/models/GBModel");
/**
 * A user and its metadata.
 */
let GuaribasUser = class GuaribasUser extends sequelize_typescript_1.Model {
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.Column,
    __metadata("design:type", Number)
], GuaribasUser.prototype, "userId", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], GuaribasUser.prototype, "displayName", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], GuaribasUser.prototype, "userSystemId", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], GuaribasUser.prototype, "userName", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], GuaribasUser.prototype, "defaultChannel", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], GuaribasUser.prototype, "email", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.STRING(5)),
    __metadata("design:type", String)
], GuaribasUser.prototype, "locale", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => GBModel_1.GuaribasInstance),
    sequelize_typescript_1.Column,
    __metadata("design:type", Number)
], GuaribasUser.prototype, "instanceId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => GBModel_1.GuaribasInstance),
    __metadata("design:type", GBModel_1.GuaribasInstance)
], GuaribasUser.prototype, "instance", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.STRING(255)),
    __metadata("design:type", String)
], GuaribasUser.prototype, "agentSystemId", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    sequelize_typescript_1.Column,
    __metadata("design:type", Date)
], GuaribasUser.prototype, "agentContacted", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.STRING(16)),
    __metadata("design:type", String)
], GuaribasUser.prototype, "agentMode", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.TEXT),
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], GuaribasUser.prototype, "conversationReference", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.STRING(64)),
    __metadata("design:type", String)
], GuaribasUser.prototype, "hearOnDialog", void 0);
GuaribasUser = __decorate([
    sequelize_typescript_1.Table
], GuaribasUser);
exports.GuaribasUser = GuaribasUser;
/**
 * A group of users.
 */
let GuaribasGroup = class GuaribasGroup extends sequelize_typescript_1.Model {
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.Column,
    __metadata("design:type", Number)
], GuaribasGroup.prototype, "groupId", void 0);
__decorate([
    sequelize_typescript_1.Length({ min: 0, max: 512 }),
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], GuaribasGroup.prototype, "displayName", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => GBModel_1.GuaribasInstance),
    sequelize_typescript_1.Column,
    __metadata("design:type", Number)
], GuaribasGroup.prototype, "instanceId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => GBModel_1.GuaribasInstance),
    __metadata("design:type", GBModel_1.GuaribasInstance)
], GuaribasGroup.prototype, "instance", void 0);
GuaribasGroup = __decorate([
    sequelize_typescript_1.Table
], GuaribasGroup);
exports.GuaribasGroup = GuaribasGroup;
/**
 * Relation of groups and users.
 */
let GuaribasUserGroup = class GuaribasUserGroup extends sequelize_typescript_1.Model {
};
__decorate([
    sequelize_typescript_1.ForeignKey(() => GuaribasUser),
    sequelize_typescript_1.Column,
    __metadata("design:type", Number)
], GuaribasUserGroup.prototype, "userId", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => GuaribasGroup),
    sequelize_typescript_1.Column,
    __metadata("design:type", Number)
], GuaribasUserGroup.prototype, "groupId", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => GBModel_1.GuaribasInstance),
    sequelize_typescript_1.Column,
    __metadata("design:type", Number)
], GuaribasUserGroup.prototype, "instanceId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => GBModel_1.GuaribasInstance),
    __metadata("design:type", GBModel_1.GuaribasInstance)
], GuaribasUserGroup.prototype, "instance", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => GuaribasGroup),
    __metadata("design:type", GuaribasGroup)
], GuaribasUserGroup.prototype, "group", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => GuaribasUser),
    __metadata("design:type", GuaribasUser)
], GuaribasUserGroup.prototype, "user", void 0);
GuaribasUserGroup = __decorate([
    sequelize_typescript_1.Table
], GuaribasUserGroup);
exports.GuaribasUserGroup = GuaribasUserGroup;
//# sourceMappingURL=index.js.map